###============================================================
##      Ubuntu 18.04 Apache Additional Domain Installer
###============================================================
## Zet comments hieronder:
#
#
#
##=============================================================

##------------##
#    Apache    #
##------------##

cp /etc/apache2/sites-available/000-default.conf /etc/apache2/sites-available/"$domain.conf"
cat <<EOF > /etc/apache2/sites-available/"$domain.conf"
<VirtualHost *:80>
    #netdata here
    ServerAdmin $email
    ServerName $domain
    ServerAlias www.$domain
    DocumentRoot /var/www/$domain/html
    <Directory "/var/www/$domain/html">
        Options FollowSymLinks
        AllowOverride All
        Order allow,deny
        Allow from all
    </Directory>
    ErrorLog \${APACHE_LOG_DIR}/error.log
    CustomLog \${APACHE_LOG_DIR}/access.log combined
</VirtualHost>
EOF
a2ensite $domain

##----------------##
#    PHPMyAdmin    #
##----------------##

# Redirect phpmyadmin -> database
ln -s /usr/share/phpmyadmin /var/www/"$domain"/html/database

##-------------##
#    Netdata    #
##-------------##

if [ $netdata = 1 ]
    then
    apt install -y netdata
    sed -i 's/SEND_EMAIL="YES"/SEND_EMAIL="NO"/g' /etc/netdata/health_alarm_notify.conf
    ufw allow 19999/tcp
    sed -i 's+#netdata here+RewriteEngine On\n  	ProxyRequests Off\n  	ProxyPreserveHost On\n    <Proxy *>\n        Require all granted\n	  </Proxy>\n    ProxyPass "/netdata/" "http://localhost:19999/" connectiontimeout=5 timeout=30 keepalive=on\n	  ProxyPassReverse "/netdata/" "http://localhost:19999/"\n	  #RewriteRule ^/netdata$ http://%{HTTP_HOST}/netdata/ [L,R=301] #HTTP\n	  RewriteRule ^/netdata$ https://%{HTTP_HOST}/netdata/ [L,R=301] #HTTPS+g' /etc/apache2/sites-available/"$domain.conf"
    # systemctl stop netdata
    # systemctl disable netdata
fi

##-------------##
#    Certbot    #
##-------------##

certbot --apache -n -d "$domain" -d "www.$domain" -m "$email" --hsts --redirect --no-eff-email --agree-tos

##---------------##
#    Wordpress    #
##---------------##

if [ $wordpress = 1 ]
    then
    db_suffix=`expr $(ls -l /var/www | grep -c ^d) - 1`
    db_name="wp_$db_suffix"
    db_user="wp_$db_suffix"
    db_pass=$(date +%s|sha256sum|base64|head -c 32)
    mysql -u root -p"$password" -e "CREATE DATABASE "$db_name" DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci;"
    mysql -u root -p"$password" -e "GRANT ALL ON "$db_name".* TO '"$db_user"'@'localhost' IDENTIFIED BY '"$db_pass"';"
    mysql -u root -p"$password" -e "FLUSH PRIVILEGES;"
    wget https://wordpress.org/latest.tar.gz -O /tmp/wp.tar.gz
    tar xzvf /tmp/wp.tar.gz -C /tmp
    mv /tmp/wordpress/wp-config-sample.php /tmp/wordpress/wp-config.php
    cp -a /tmp/wordpress/. /var/www/"$domain"/html
    WPSalts=$(wget https://api.wordpress.org/secret-key/1.1/salt/ -q -O -)
cat <<EOF > /var/www/"$domain"/html/wp-config.php
<?php
define('DB_NAME', '$db_name');
define('DB_USER', '$db_user');
define('DB_PASSWORD', '$db_pass');
define('DB_HOST', 'localhost');
define('DB_CHARSET', 'utf8');
define('DB_COLLATE', '');
#define( 'WP_SITEURL', '' );
#define( 'WP_HOME', '' );
#define( 'ALTERNATE_WP_CRON', true );
#define('DISABLE_WP_CRON', 'true');
#define('WP_CRON_LOCK_TIMEOUT', 900);
#define('AUTOSAVE_INTERVAL', 300);
define( 'WP_MEMORY_LIMIT', '256M' );
define( 'DISALLOW_FILE_EDIT', true );
#define( 'EMPTY_TRASH_DAYS', 7 );
define( 'NOBLOGREDIRECT', 'https://$domain' );
#define( 'FS_CHMOD_DIR', ( 0755 & ~ umask() ) );
#define( 'FS_CHMOD_FILE', ( 0644 & ~ umask() ) );
#define( 'WP_ALLOW_REPAIR', true );
#define( 'FORCE_SSL_ADMIN', true );
#define( 'AUTOMATIC_UPDATER_DISABLED', true );
#define( 'WP_AUTO_UPDATE_CORE', false );
$WPSalts
\$table_prefix = '$db_name';

define('WP_DEBUG', false);
if ( !defined('ABSPATH') )
	define('ABSPATH', dirname(__FILE__) . '/');

#\$memcached_servers = array(
#    'default' => array(
#        '127.0.0.1:11211'
#    )
#);
#define('WP_REDIS_HOST', '127.0.0.1');
#define('WP_REDIS_PASSWORD', '$password');
#define('WP_REDIS_PORT', '6379');
require_once(ABSPATH . 'wp-settings.php');
EOF
fi

##-----------------##
#    Opcache GUI    #
##-----------------##

wget https://raw.githubusercontent.com/amnuts/opcache-gui/master/index.php -O /var/www/"$domain"/html/opcache.php

##--------------##
#    Info.php    #
##--------------##

cat > /var/www/"$domain"/html/info.php <<- "EOF"
<?php
phpinfo();
EOF

##-----------------------##
#    Html Folder Perms    #
##-----------------------##

chown -R www-data:www-data /var/www/"$domain"/html